package com.thebrokenrail.reliccraft.item;

import com.thebrokenrail.reliccraft.RelicCraft;
import net.minecraft.block.Block;
import net.minecraft.inventory.Inventories;
import net.minecraft.item.BlockItem;
import net.minecraft.item.ItemGroup;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.util.DefaultedList;
import net.minecraft.util.Identifier;
import net.minecraft.util.Rarity;

public class DragonEggHolderBlockItem extends BlockItem {
    public DragonEggHolderBlockItem(Block block) {
        super(block, new Settings().rarity(Rarity.UNCOMMON).group(ItemGroup.MISC));
        addPropertyGetter(new Identifier(RelicCraft.NAMESPACE, "active"), (stack, world, entity) -> {
            CompoundTag tag = stack.getSubTag("BlockEntityTag");
            if (tag != null) {
                DefaultedList<ItemStack> list = DefaultedList.ofSize(1, ItemStack.EMPTY);
                Inventories.fromTag(tag, list);
                if (!list.get(0).isEmpty()) {
                    return 1;
                }
            }
            return 0;
        });
    }
}
