package com.thebrokenrail.reliccraft.mixin;

import com.thebrokenrail.reliccraft.block.TeleportationRestrictorBlock;
import net.minecraft.entity.LivingEntity;
import net.minecraft.entity.thrown.ThrownEnderpearlEntity;
import net.minecraft.util.hit.HitResult;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

@SuppressWarnings("unused")
@Mixin(ThrownEnderpearlEntity.class)
public class MixinThrownEnderpearlEntity {
    @Inject(at = @At("HEAD"), method = "onCollision", cancellable = true)
    public void onCollision(HitResult hitResult, CallbackInfo info) {
        LivingEntity owner = ((ThrownEnderpearlEntity) (Object) this).getOwner();
        if (owner != null && ((TeleportationRestrictorBlock.TeleportingEntity) owner).cannotTeleport()) {
            ((ThrownEnderpearlEntity) (Object) this).remove();
            info.cancel();
        }
    }
}
